MCDParser Class Reference

the main class to read a MacDoc file More...

`#include <MCDParser.hxx>`

Inheritance diagram for MCDParser:

## Public Member Functions

| MCDParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~MCDParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (WPXDocumentInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
void | setVersion (int vers)
| sets the works version More...

## Protected Member Functions

void | init ()
| inits all internal variables More...
void | createDocument (WPXDocumentInterface *documentInterface)
| creates the listener which will be associated to the document More...
void | newPage (int number)
| adds a new page More...
bool | createZones ()
| finds the different objects zones More...
bool | sendContents ()
| try to send the contents More...
bool | sendPicture (MWAWEntry const &entry)
| try to send a picture More...
bool | readFont (MWAWEntry const &entry)
| try to read a font index entry More...
bool | readIndex (MWAWEntry const &entry)
| try to read an index entry More...
int | updateIndex (int actIndex, int actLevel)
| try to set the index level and return the next index value (or -1) More...
bool | readBookmark (MWAWEntry const &entry)
| try to read a bookmark entry More...
bool | readFile (MWAWEntry const &entry)
| try to read a file entry More...
bool | readWP (MWAWEntry const &entry)
| try to read a MDwp entry (window pos?) More...
bool | sendIndex ()
| try to send the index More...
MWAWInputStreamPtr | rsrcInput ()
| return the input input More...
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWContentListenerPtr & | getListener ()
| returns the listener More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
void | setListener (MWAWContentListenerPtr &listener)
| sets the listener More...
void | resetListener ()
| resets the listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
void | setFontConverter (MWAWFontConverterPtr fontConverter)
| sets the font convertor More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes

shared_ptr < MCDParserInternal::State > | m_state
| the state More...

## Friends

class | MCDText

## Detailed Description

the main class to read a MacDoc file

## Constructor & Destructor Documentation

MCDParser::MCDParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

MCDParser::~MCDParser | ( |  | ) |

virtual

destructor

## Member Function Documentation

bool MCDParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |

virtual

checks if the document header is correct (or not)

no data fork, may be ok, but this means that the file contains no text, so...

Implements MWAWParser.

Referenced by parse().

void MCDParser::createDocument | ( | WPXDocumentInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by parse().

bool MCDParser::createZones | ( |  | ) |

protected

finds the different objects zones

Referenced by parse().

void MCDParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by MCDParser().

void MCDParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by sendContents().

void MCDParser::parse | ( | WPXDocumentInterface * | documentInterface | ) |

virtual

virtual function used to parse the input

Implements MWAWParser.

bool MCDParser::readBookmark | ( | MWAWEntry const & | entry | ) |

protected

try to read a bookmark entry

Referenced by createZones().

bool MCDParser::readFile | ( | MWAWEntry const & | entry | ) |

protected

try to read a file entry

Referenced by createZones().

bool MCDParser::readFont | ( | MWAWEntry const & | entry | ) |

protected

try to read a font index entry

Referenced by createZones().

bool MCDParser::readIndex | ( | MWAWEntry const & | entry | ) |

protected

try to read an index entry

Referenced by createZones().

bool MCDParser::readWP | ( | MWAWEntry const & | entry | ) |

protected

try to read a MDwp entry (window pos?)

Referenced by createZones().

libmwaw::DebugFile & MCDParser::rsrcAscii | ( |  | ) |

protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by createZones(), readBookmark(), readFile(), readFont(), readIndex(), and readWP().

MWAWInputStreamPtr MCDParser::rsrcInput | ( |  | ) |

protected

return the input input

Referenced by readBookmark(), readFile(), readFont(), readIndex(), readWP(), and sendIndex().

bool MCDParser::sendContents | ( |  | ) |

protected

try to send the contents

Referenced by parse().

bool MCDParser::sendIndex | ( |  | ) |

protected

try to send the index

Referenced by sendContents().

bool MCDParser::sendPicture | ( | MWAWEntry const & | entry | ) |

protected

try to send a picture

Referenced by sendContents().

int MCDParser::updateIndex | ( | int | actIndex,
|  | int | actLevel
| ) |  |

protected

try to set the index level and return the next index value (or -1)

Referenced by sendIndex().

## Friends And Related Function Documentation

friend class MCDText

friend

## Member Data Documentation

shared_ptr<MCDParserInternal::State> MCDParser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), init(), newPage(), readFont(), readIndex(), sendContents(), sendIndex(), and updateIndex().

The documentation for this class was generated from the following files:

- MCDParser.hxx
- MCDParser.cxx